#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

//define for AdultPdfSetFunction
#define AdultPdf_Set_MultiPage			101
#define AdultPdf_Set_ImagePosAndSize	104
#define AdultPdf_Set_Encrypt 			105
#define AdultPdf_Set_Font				106
#define AdultPdf_Set_NewOrClosePage		109
#define AdultPdf_Set_BookMark			110
#define AdultPdf_Set_ViewerPreferences	121

//define for AdultPdfGetFunction
#define AdultPdf_Get_ImagePageCount		201
#define AdultPdf_Get_ImageSizeW			202
#define AdultPdf_Get_ImageSizeH			203
#define AdultPdf_Get_ImageDpiX			204
#define AdultPdf_Get_ImageDpiY			205
#define AdultPdf_Get_PdfPageCount		206
#define AdultPdf_Get_PdfCurrentPageSize	209
#define AdultPdf_Get_StringWidth		250
#define AdultPdf_Get_StringHeight		251

//define for AdultPdfAddText
#define AdultPdf_DT_LEFT			0
#define AdultPdf_DT_CENTER		1
#define AdultPdf_DT_RIGHT		2
#define AdultPdf_DT_WORDBREAK	0x10
#define AdultPdf_DT_CALCRECT		0x400

typedef long	(__stdcall *AdultPdfCreate)(char *);
typedef void	(__stdcall *AdultPdfClose)(long);
typedef long	(__stdcall *AdultPdfAddInfo)(long,char*,char*,char*,char*,char*);
typedef long	(__stdcall *AdultPdfSetFunction)(long,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *AdultPdfGetFunction)(long,long func_code,long para1,long para2,char *para3,char *para4);

typedef long	(__stdcall *AdultPdfAddImage)(long,char *);
typedef long	(__stdcall *AdultPdfAddImageData)(long,char *,long ,long ,long );

typedef long	(__stdcall *AdultPdfAddTextEx)(long,long,long,char *,long );
typedef long	(__stdcall *AdultPdfAddText)(long,long,long,long,long,char *,long ,long,long);
typedef long	(__stdcall *AdultPdfAddTxt)(long id,char *szTxtName,long color,
						   long width,long height,long AutoNewLine,long AutoWidthAdjust,
						   long LeftMargin,long RightMargin,long TopMargin,long BottomMargin,
						   long TabSize);

typedef long	(__stdcall *AdultPdfAddLine)  (long ,long ,long ,long ,long ,long ,long );
typedef long	(__stdcall *AdultPdfAddRect  )(long ,long ,long ,long ,long ,long ,long ,long ,long );


HMODULE				g_hAdultPdfW=NULL;

AdultPdfCreate			pAdultPdfCreate;
AdultPdfAddImage		pAdultPdfAddImage;
AdultPdfAddImageData	pAdultPdfAddImageData;
AdultPdfClose			pAdultPdfClose	;	
AdultPdfAddInfo			pAdultPdfAddInfo;	
AdultPdfSetFunction		pAdultPdfSetFunction;
AdultPdfGetFunction		pAdultPdfGetFunction;
AdultPdfAddTextEx		pAdultPdfAddTextEx;
AdultPdfAddText			pAdultPdfAddText;
AdultPdfAddTxt			pAdultPdfAddTxt;
AdultPdfAddLine			pAdultPdfAddLine;
AdultPdfAddRect			pAdultPdfAddRect;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadAdultPdfWDll(void);
void	FreeAdultPdfWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadAdultPdfWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"ImageToPDF.dll");
	g_hAdultPdfW=LoadLibrary(path);
	if(g_hAdultPdfW==NULL)
		goto Failer;

	pAdultPdfCreate=(AdultPdfCreate)GetProcAddress(g_hAdultPdfW,"AdultPdfCreate");
	if(pAdultPdfCreate==NULL)
		goto Failer;
	pAdultPdfAddImage=(AdultPdfAddImage)GetProcAddress(g_hAdultPdfW,"AdultPdfAddImage");
	if(pAdultPdfAddImage==NULL)
		goto Failer;
	pAdultPdfAddImageData=(AdultPdfAddImageData)GetProcAddress(g_hAdultPdfW,"AdultPdfAddImageData");
	if(pAdultPdfAddImageData==NULL)
		goto Failer;
	pAdultPdfClose=(AdultPdfClose)GetProcAddress(g_hAdultPdfW,"AdultPdfClose");
	if(pAdultPdfClose==NULL)
		goto Failer;
	pAdultPdfAddInfo=(AdultPdfAddInfo)GetProcAddress(g_hAdultPdfW,"AdultPdfAddInfo");
	if(pAdultPdfAddInfo==NULL)
		goto Failer;
	pAdultPdfSetFunction=(AdultPdfSetFunction)GetProcAddress(g_hAdultPdfW,"AdultPdfSetFunction");
	if(pAdultPdfSetFunction==NULL)
		goto Failer;
	pAdultPdfGetFunction=(AdultPdfGetFunction)GetProcAddress(g_hAdultPdfW,"AdultPdfGetFunction");
	if(pAdultPdfGetFunction==NULL)
		goto Failer;
	pAdultPdfAddTextEx=(AdultPdfAddTextEx)GetProcAddress(g_hAdultPdfW,"AdultPdfAddTextEx");
	if(pAdultPdfAddTextEx==NULL)
		goto Failer;
	pAdultPdfAddText=(AdultPdfAddText)GetProcAddress(g_hAdultPdfW,"AdultPdfAddText");
	if(pAdultPdfAddText==NULL)
		goto Failer;
	pAdultPdfAddTxt=(AdultPdfAddTxt)GetProcAddress(g_hAdultPdfW,"AdultPdfAddTxt");
	if(pAdultPdfAddTxt==NULL)
		goto Failer;
	pAdultPdfAddLine=(AdultPdfAddLine)GetProcAddress(g_hAdultPdfW,"AdultPdfAddLine");
	if(pAdultPdfAddLine==NULL)
		goto Failer;
	pAdultPdfAddRect=(AdultPdfAddRect)GetProcAddress(g_hAdultPdfW,"AdultPdfAddRect");
	if(pAdultPdfAddRect==NULL)
		goto Failer;
	return TRUE;
Failer:
	FreeAdultPdfWDll(); 
	return FALSE;

}

void FreeAdultPdfWDll()
{
	if(g_hAdultPdfW==NULL)
		return ;
	FreeLibrary(g_hAdultPdfW);
	g_hAdultPdfW=NULL;
}



void AddImageData(long id)
{
	int i,j;
	int temp1,temp2;
	int red,green,blue;
	int MemImageWidth=640;
	int MemImageHeight=640;
	int color=24;//can equal 1 and 8 and 24
	char *MemData=malloc(MemImageWidth*MemImageHeight*3);
	for(i=0;i<MemImageHeight - 1;i++){
		for(j=0;j<MemImageWidth - 1;j++){
			temp1=i&8;
			temp2=j&8;
			if(temp1|temp2){
				red=255;
				green = blue = 0;
			}else{
                red = 0;
                green = blue = 255	;		
			}
            MemData[i * MemImageWidth * 3 + j * 3 + 0] = red;
            MemData[i * MemImageWidth * 3 + j * 3 + 1] = green;
            MemData[i * MemImageWidth * 3 + j * 3 + 2] = blue;
		}
	}

	pAdultPdfAddImageData(id,MemData,MemImageWidth,MemImageHeight,color);

	free(MemData);
	MemData=NULL;
}


void main()
{
	char szPDFFile[256];
	char szImageFile[256];
	long code;
	long beginpage;
	long pagenums;
	long id;
	long width,height,xdpi,ydpi;

	memset(szPDFFile,0,256);
	memset(szImageFile,0,256);

	if(!LoadAdultPdfWDll())
		return ;

	GetModulePath(szPDFFile,"create.pdf");
	id=pAdultPdfCreate(szPDFFile);
	if(id>0){
		int pagenum; 
		int i;

		//set password and permission
		#define permission_Print	1
		#define permission_Copy		2
		#define permission_Modify	4
		pAdultPdfSetFunction(id,AdultPdf_Set_Encrypt,128,permission_Copy+permission_Modify,"111","222");

		pAdultPdfAddInfo(id,"Title","Subject","Author","Keywords","Creator");
		pAdultPdfSetFunction(id,AdultPdf_Set_ViewerPreferences,4+4096,2,0,0);

		GetModulePath(szImageFile,"multipage.tif");
		//add bookmark
		pAdultPdfSetFunction(id,AdultPdf_Set_BookMark,0,0,"bookmark one",0);

		//get multi page tiff page nums
		pagenum=pAdultPdfGetFunction(id,AdultPdf_Get_ImagePageCount,0,0,szImageFile,0);
		if(pagenum>4){
			//set multi page tiff convert
			code=AdultPdf_Set_MultiPage;
			beginpage=1;
			pagenums=2;
			pAdultPdfSetFunction(id,code,beginpage,pagenums,0,0);
		}
		if(pagenum)
			pAdultPdfAddImage(id,szImageFile);

		GetModulePath(szImageFile,"test1.jpg");
		//add bookmark
		pAdultPdfSetFunction(id,AdultPdf_Set_BookMark,0,0,"bookmark two",0);
		pagenum=pAdultPdfGetFunction(id,AdultPdf_Get_ImagePageCount,0,0,szImageFile,0);
		for(i=1; i<=pagenum; i++)
		{
			char buf[32];
			char buf2[32];
			long iret;
			iret=pAdultPdfGetFunction(id,AdultPdf_Get_ImageSizeW,(long)&width,(long)&height,szImageFile,ltoa(i,buf,10));
			//Get image dpi (Resolution)
			iret=pAdultPdfGetFunction(id,AdultPdf_Get_ImageDpiX,(long)&xdpi,(long)&ydpi,szImageFile,ltoa(i,buf,10));
			if(xdpi>0&&ydpi>0){
 				width  = (long)(width * (72.0/xdpi));
 				height = (long)(height* (72.0/ydpi));
			}
			//new page
			iret=pAdultPdfSetFunction(id,AdultPdf_Set_NewOrClosePage,width,height,0,0);
			//set image size
			iret=pAdultPdfSetFunction(id,AdultPdf_Set_ImagePosAndSize,0,0,ltoa(width,buf,10),ltoa(height,buf2,10));
			//add image one
			iret=pAdultPdfSetFunction(id,101,i,1,0,0);
			iret=pAdultPdfAddImage(id,szImageFile);
			//close the page
			iret=pAdultPdfSetFunction(id,AdultPdf_Set_NewOrClosePage,0,0,0,0);
		}

		//other file
		pAdultPdfAddImage(id,"test.wmf");
		
		//add bookmark
		pAdultPdfSetFunction(id,AdultPdf_Set_BookMark,0,0,"bookmark three",0);
		//add image four, the example for bit 24 bmp
		AddImageData(id);

		//new a page for a3
		pAdultPdfSetFunction(id,AdultPdf_Set_NewOrClosePage,1,1,0,0);
		//add bookmark
		pAdultPdfSetFunction(id,AdultPdf_Set_BookMark,0,0,"bookmark four",0);

		//set system font and size
		pAdultPdfSetFunction(id,AdultPdf_Set_Font,1,32,"Arial",0);
		//add text
		pAdultPdfAddTextEx(id,300,300,"this is a text!",RGB(0,255,255));

		//set system font and size
		pAdultPdfSetFunction(id,AdultPdf_Set_Font,1,32,"Helvetica",0);
		//add text
		pAdultPdfAddTextEx(id,300,400,"this is a text!",RGB(0,255,255));

		//set system font and size
		pAdultPdfSetFunction(id,AdultPdf_Set_Font,1,32,"Verdana",0);
		//add text
		pAdultPdfAddTextEx(id,300,500,"this is a text!",RGB(0,255,255));

		//set font and size
		pAdultPdfSetFunction(id,AdultPdf_Set_Font,203,32,0,0);

		{
		char string[]="this is a text! this is a text! this is a text! this is a text!";
		//width =pAdultPdfGetFunction(id,AdultPdf_Get_StringWidth,0,0,string,0);
		//height=pAdultPdfGetFunction(id,AdultPdf_Get_StringHeight,0,0,string,0);
		//add text for rect
		width=200;  
		height=0;
		pAdultPdfAddText(id,1,1,(long)&width,(long)&height,string,
					 RGB(0,0,255),RGB(255,0,255),AdultPdf_DT_WORDBREAK|AdultPdf_DT_CALCRECT); 
		pAdultPdfAddText(id,1,1,width,height,string,
					 RGB(0,0,255),RGB(255,0,255),AdultPdf_DT_WORDBREAK|AdultPdf_DT_CENTER); 
		//pAdultPdfAddText(id,1,1,width,height,string,
		//			 RGB(0,0,255),RGB(255,0,255),AdultPdf_DT_WORDBREAK|AdultPdf_DT_CENTER); 
		}

		//new a page for b5
		pAdultPdfSetFunction(id,AdultPdf_Set_NewOrClosePage,4,4,0,0);
		//add bookmark
		pAdultPdfSetFunction(id,AdultPdf_Set_BookMark,0,0,"bookmark five",0);
		//add graphic
		pAdultPdfAddLine  (id,10,10,100,200,5,RGB(0,0,255));
		pAdultPdfAddRect(id,20,210,300,400,3,RGB(0,255,0),1,RGB(255,0,255));

		GetModulePath(szImageFile,"test.txt");
		pAdultPdfSetFunction(id,AdultPdf_Set_Font,200,16,0,0);
		pAdultPdfAddTxt(id,szImageFile,0,0,0,1,1,64,64,64,64,4);

		pAdultPdfClose(id);
	}
	FreeAdultPdfWDll();

}